package ru.itmo.stat.gibdd.aggregator.configuration;

import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import ru.itmo.stat.gibdd.aggregator.parser.StatGibddParser;
import ru.itmo.stat.gibdd.aggregator.service.*;

@Configuration
public class ParsingConfiguration {
    @Bean
    public StatGibddParser statGibddParser(AccidentTypeService accidentTypeService,
                                           RoadConditionService roadConditionService,
                                           IlluminationService illuminationService,
                                           DistrictService districtService,
                                           RoadTrafficChangeService roadTrafficChangeService,
                                           RoadImportanceService roadImportanceService,
                                           StreetCategoryService streetCategoryService,
                                           RoadService roadService,
                                           StreetService streetService,
                                           SettlementNameService settlementNameService,
                                           AccidentWeatherService accidentWeatherService,
                                           AccidentCardService accidentCardService,
                                           AccidentDrivingModeFactorService accidentDrivingModeFactorService,
                                           AccidentRoadMaintenanceDisadvantageService accidentRoadMaintenanceDisadvantageService,
                                           AccidentRoadNetworkObjectService accidentRoadNetworkObjectService,
                                           AccidentPlaceStatusService accidentPlaceStatusService,
                                           VehicleColorService vehicleColorService,
                                           VehicleDamageService vehicleDamageService,
                                           VehicleMalfunctionService vehicleMalfunctionService,
                                           VehicleModelService vehicleModelService,
                                           VehicleOwnershipService vehicleOwnershipService,
                                           AccidentVehicleService accidentVehicleService,
                                           VehicleService vehicleService,
                                           AccidentParticipantService accidentParticipantService,
                                           ParticipantCategoryService participantCategoryService,
                                           ParticipantMainTrafficViolationService participantMainTrafficViolationService,
                                           ParticipantRelatedTrafficViolationService participantRelatedTrafficViolationService,
                                           ParticipantService participantService,
                                           ParticipantStatusService participantStatusService,
                                           SeatTypeService seatTypeService,
                                           TrafficViolationService trafficViolationService,
                                           VehicleTypeService vehicleTypeService) {
        return new StatGibddParser(accidentTypeService, roadConditionService, illuminationService,
                districtService, roadTrafficChangeService, roadImportanceService, streetCategoryService,
                roadService, streetService, settlementNameService, accidentWeatherService, accidentCardService,
                accidentDrivingModeFactorService, accidentRoadMaintenanceDisadvantageService, accidentRoadNetworkObjectService,
                accidentPlaceStatusService, vehicleColorService, vehicleDamageService, vehicleMalfunctionService,
                vehicleModelService, vehicleOwnershipService, vehicleService, accidentVehicleService,
                accidentParticipantService, participantCategoryService, participantMainTrafficViolationService, participantRelatedTrafficViolationService,
                participantService, participantStatusService, seatTypeService, trafficViolationService, vehicleTypeService);
    }
}




