package ru.itmo.stat.gibdd.aggregator.controller;

import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.*;
import ru.itmo.stat.gibdd.aggregator.domain.entities.AccidentCardCluster;
import ru.itmo.stat.gibdd.aggregator.service.AccidentCardClusterService;
import ru.itmo.stat.gibdd.aggregator.service.AccidentCardService;

@RestController
@RequiredArgsConstructor
@RequestMapping("/cluster")
@Slf4j
public class ClusterController {
    private final AccidentCardService accidentCardService;
    private final AccidentCardClusterService accidentCardClusterService;

    @GetMapping(value= "/coordinates")
    public ResponseEntity<String> getCoordinatesInfo() {
        return new ResponseEntity<>(accidentCardService.getCoordinatesInfo(), HttpStatus.OK);
    }

    @GetMapping(value = "/dead_count")
    public ResponseEntity<String> getDeadCountInfo() {
        return new ResponseEntity<>(accidentCardService.getDeadCountInfo(), HttpStatus.OK);
    }

    @GetMapping(value = "/vehicle_count")
    public ResponseEntity<String> getVehicleCountInfo() {
        return new ResponseEntity<>(accidentCardService.getVehicleCountInfo(), HttpStatus.OK);
    }

    @GetMapping(value = "/participant_count")
    public ResponseEntity<String> getParticipantCountInfo() {
        return new ResponseEntity<>(accidentCardService.getParticipantCountInfo(), HttpStatus.OK);
    }

    @GetMapping(value = "/accident_type")
    public ResponseEntity<String> getAccidentTypeInfo() {
        return new ResponseEntity<>(accidentCardService.getAccidentTypeInfo(), HttpStatus.OK);
    }

    @GetMapping(value = "/road_conditions")
    public ResponseEntity<String> getRoadConditionsInfo() {
        return new ResponseEntity<>(accidentCardService.getRoadConditionsInfo(), HttpStatus.OK);
    }

    @GetMapping(value = "/illumination")
    public ResponseEntity<String> getIlluminationInfo() {
        return new ResponseEntity<>(accidentCardService.getIlluminationInfo(), HttpStatus.OK);
    }

    @GetMapping(value = "/cards")
    public ResponseEntity<String> getCards() {
        return new ResponseEntity<>(accidentCardService.getCards(), HttpStatus.OK);
    }

    @PostMapping(value = "/cluster")
    public ResponseEntity<String> addClusters(@RequestBody String data) {
        log.info("/cluster");
        accidentCardClusterService.addClusters(data);
        return new ResponseEntity<>(HttpStatus.OK);
    }
}
