package ru.itmo.stat.gibdd.aggregator.domain.dto;

import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;
import org.geolatte.geom.G2D;
import org.geolatte.geom.Point;
import org.hibernate.annotations.Type;

import javax.persistence.Column;
import javax.persistence.ElementCollection;
import java.time.LocalDate;
import java.time.LocalTime;
import java.util.Collection;
import java.util.List;

@AllArgsConstructor
@NoArgsConstructor
@Data
public class AccidentCardDto implements AbstractDto<String> {
    private Long id;

    private LocalDate date;

    private LocalTime time;

    private DistrictDto district;

    private AccidentTypeDto accidentType;

    private int deadCount;

    private int injuredCount;

    private int vehicleCount;

    private int participantCount;

    private Point<G2D> accidentCoordinates;

    private RoadConditionDto roadCondition;

    private IlluminationDto illumination;

    private String accidentS;

    private RoadTrafficChangeDto roadTrafficChange;

    private RoadImportanceDto roadImportance;

    private int roadCategory;

    private StreetCategoryDto streetCategory;

    private double distance;

    private RoadDto road;

    private String house;

    private StreetDto street;

    private SettlementNameDto settlementName;

}
