package ru.itmo.stat.gibdd.aggregator.domain.entities;

import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;
import org.geolatte.geom.G2D;
import org.geolatte.geom.Point;

import javax.persistence.*;
import java.time.LocalDate;
import java.time.LocalTime;

@Entity
@Data
@AllArgsConstructor
@NoArgsConstructor
@Table(name = "stat_gibdd_accident_cards")
public class AccidentCard implements AbstractEntity<String> {
    @Id
    private Long id;

    private LocalDate date;

    private LocalTime time;

    @JoinColumn(name = "district")
    @ManyToOne(fetch = FetchType.LAZY)
    private District district;

    @JoinColumn(name = "accident_type")
    @ManyToOne(fetch = FetchType.LAZY)
    private AccidentType accidentType;

    private int deadCount;

    private int injuredCount;

    private int vehicleCount;

    private int participantCount;

    private Point<G2D> accidentCoordinates;

    @JoinColumn(name = "road_condition")
    @ManyToOne(fetch = FetchType.LAZY)
    private RoadCondition roadCondition;

    @JoinColumn(name = "illumination")
    @ManyToOne(fetch = FetchType.LAZY)
    private Illumination illumination;

    @Column(name = "accident_s")
    private String accidentS;

    @JoinColumn(name = "road_traffic_change")
    @ManyToOne(fetch = FetchType.LAZY)
    private RoadTrafficChange roadTrafficChange;

    @JoinColumn(name = "road_importance")
    @ManyToOne(fetch = FetchType.LAZY)
    private RoadImportance roadImportance;

    private int roadCategory;

    @JoinColumn(name = "street_category")
    @ManyToOne(fetch = FetchType.LAZY)
    private StreetCategory streetCategory;

    private double distance;

    @JoinColumn(name = "road")
    @ManyToOne(fetch = FetchType.LAZY)
    private Road road;

    private String house;

    @JoinColumn(name = "street")
    @ManyToOne(fetch = FetchType.LAZY)
    private Street street;

    @JoinColumn(name = "settlement_name")
    @ManyToOne(fetch = FetchType.LAZY)
    private SettlementName settlementName;

}
