package ru.itmo.stat.gibdd.aggregator.domain.entities;

import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;

import javax.persistence.*;

@Entity
@Data
@AllArgsConstructor
@NoArgsConstructor
@Table(name = "stat_gibdd_participants")
public class Participant implements AbstractEntity<String> {
    @Id
    private String id;

    private int participantNumber;

    private int drivingExperience;

    private int alcohol;

    private boolean safetyBeltUsed;

    @JoinColumn(name = "seat_type")
    @ManyToOne(fetch = FetchType.LAZY)
    private SeatType seatType;

    @JoinColumn(name = "participant_category")
    @ManyToOne(fetch = FetchType.LAZY)
    private ParticipantCategory participantCategory;

    private String injuredCardId;

    private String sex;

    @JoinColumn(name = "accident_place_status")
    @ManyToOne(fetch = FetchType.LAZY)
    private AccidentPlaceStatus accidentPlaceStatus;

    @JoinColumn(name = "participant_status")
    @ManyToOne(fetch = FetchType.LAZY)
    private ParticipantStatus participantStatus;
}
