package ru.itmo.stat.gibdd.aggregator.domain.entities;

import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;

import javax.persistence.*;

@Entity
@Data
@AllArgsConstructor
@NoArgsConstructor
@Table(name = "stat_gibdd_vehicles")
public class Vehicle implements AbstractEntity<String> {
    @Id
    private String id;

    private Long vehicleNumber;

    private int manufactureYear;

    @JoinColumn(name = "vehicle_accident_place_status")
    @ManyToOne(fetch = FetchType.LAZY)
    private AccidentPlaceStatus accidentPlaceStatus;

    @JoinColumn(name = "vehicle_model")
    @ManyToOne(fetch = FetchType.LAZY)
    private VehicleModel vehicleModel;

    @JoinColumn(name = "vehicle_color")
    @ManyToOne(fetch = FetchType.LAZY)
    private VehicleColor vehicleColor;

    @JoinColumn(name = "vehicle_type")
    @ManyToOne(fetch = FetchType.LAZY)
    private VehicleType vehicleType;

    @JoinColumn(name = "vehicle_damage")
    @ManyToOne(fetch = FetchType.LAZY)
    private VehicleDamage vehicleDamage;

    @JoinColumn(name = "vehicle_malfunction")
    @ManyToOne(fetch = FetchType.LAZY)
    private VehicleMalfunction vehicleMalfunction;

    @JoinColumn(name = "vehicle_ownership")
    @ManyToOne(fetch = FetchType.LAZY)
    private VehicleOwnership vehicleOwnership;
}
