package ru.itmo.stat.gibdd.aggregator.service;

import org.modelmapper.ModelMapper;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import ru.itmo.stat.gibdd.aggregator.domain.dto.AccidentCardClusterDto;
import ru.itmo.stat.gibdd.aggregator.domain.dto.AccidentCardDto;
import ru.itmo.stat.gibdd.aggregator.domain.entities.AccidentCard;
import ru.itmo.stat.gibdd.aggregator.domain.entities.AccidentCardCluster;
import ru.itmo.stat.gibdd.aggregator.repository.AccidentCardClusterRepository;
import ru.itmo.stat.gibdd.aggregator.repository.AccidentCardRepository;

import java.util.Scanner;

@Service
public class AccidentCardClusterService extends AbstractService<String, AccidentCardClusterDto, AccidentCardCluster, AccidentCardClusterRepository> {
    private final AccidentCardClusterRepository accidentCardClusterRepository;
    private final AccidentCardService accidentCardService;
    private final AccidentCardRepository accidentCardRepository;
    @Autowired
    public AccidentCardClusterService(AccidentCardClusterRepository repository, ModelMapper modelMapper, AccidentCardClusterRepository accidentCardClusterRepository, AccidentCardService accidentCardService, AccidentCardRepository accidentCardRepository) {
        super(repository, modelMapper);
        this.accidentCardClusterRepository = accidentCardClusterRepository;
        this.accidentCardService = accidentCardService;
        this.accidentCardRepository = accidentCardRepository;
    }

    @Override
    public Class<AccidentCardCluster> getEntityClass() {
        return AccidentCardCluster.class;
    }

    @Override
    public Class<AccidentCardClusterDto> getDTOClass() {
        return AccidentCardClusterDto.class;
    }

    public void addClusters(String data) {
        Scanner scanner = new Scanner(data);
        String[] info = scanner.nextLine().trim().replaceAll(" +", " ").split(" ");
        while (scanner.hasNextLine()) {
            String[] line = scanner.nextLine().trim().replaceAll(" +", " ").split(" ");
            AccidentCardClusterDto accidentCardClusterDto = new AccidentCardClusterDto();
            try {
                accidentCardClusterDto = modelMapper.map(accidentCardClusterRepository.findAccidentCardClusterById(Long.parseLong(line[0])), getDTOClass());
            } catch (IllegalArgumentException e) {
                accidentCardClusterDto.setId(Long.parseLong(line[0]));
                this.create(accidentCardClusterDto);
            }
            accidentCardClusterDto.setId(Long.parseLong(line[0]));

            switch (info[1]) {
                case ("class_dead_count"):
                    accidentCardClusterDto.setClassDeadCount(Integer.parseInt(line[1]));
                    break;
                case ("class_vehicle_count"):
                    accidentCardClusterDto.setClassVehicleCount(Integer.parseInt(line[1]));
                    break;
                case ("class_participant_count"):
                    accidentCardClusterDto.setClassParticipantCount(Integer.parseInt(line[1]));
                    break;
                case ("class_accident_type"):
                    accidentCardClusterDto.setClassAccidentType(Integer.parseInt(line[1]));
                    break;
                case ("class_road_conditions"):
                    accidentCardClusterDto.setClassRoadConditions(Integer.parseInt(line[1]));
                    break;
                case ("class_illumination"):
                    accidentCardClusterDto.setClassIllumination(Integer.parseInt(line[1]));
                    break;
                case ("class"):
                    accidentCardClusterDto.setClassClass(Integer.parseInt(line[1]));
                    break;
            }
            this.update(accidentCardClusterDto);
        }
    }
}
