package ru.itmo.stat.gibdd.aggregator.service;

import org.modelmapper.ModelMapper;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import ru.itmo.stat.gibdd.aggregator.domain.dto.AccidentDrivingModeFactorDto;
import ru.itmo.stat.gibdd.aggregator.domain.entities.AccidentDrivingModeFactor;
import ru.itmo.stat.gibdd.aggregator.repository.AccidentDrivingModeFactorRepository;

import java.util.List;

@Service
public class AccidentDrivingModeFactorService extends AbstractService<String, AccidentDrivingModeFactorDto, AccidentDrivingModeFactor, AccidentDrivingModeFactorRepository> {
    private final AccidentDrivingModeFactorRepository accidentDrivingModeFactorRepository;
    private final DrivingModeFactorService drivingModeFactorService;

    @Autowired
    public AccidentDrivingModeFactorService(AccidentDrivingModeFactorRepository repository, ModelMapper modelMapper, AccidentDrivingModeFactorRepository accidentDrivingModeFactorRepository, DrivingModeFactorService drivingModeFactorService) {
        super(repository, modelMapper);
        this.accidentDrivingModeFactorRepository = accidentDrivingModeFactorRepository;
        this.drivingModeFactorService = drivingModeFactorService;
    }

    @Override
    public Class<AccidentDrivingModeFactor> getEntityClass() {
        return AccidentDrivingModeFactor.class;
    }

    @Override
    public Class<AccidentDrivingModeFactorDto> getDTOClass() {
        return AccidentDrivingModeFactorDto.class;
    }

    public void addAccidentDrivingModeFactor(Long cardId, List<String> accidentDrivingModeFactor) {
        for (String w :
                accidentDrivingModeFactor) {
            AccidentDrivingModeFactorDto accidentDrivingModeFactorDto = new AccidentDrivingModeFactorDto();
            accidentDrivingModeFactorDto.setAccidentId(cardId);
            accidentDrivingModeFactorDto.setDrivingModeFactorId(drivingModeFactorService.getDrivingModeFactor(w).getId());
            this.create(accidentDrivingModeFactorDto);
        }
    }
}