package ru.itmo.stat.gibdd.aggregator.service;

import org.modelmapper.ModelMapper;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import ru.itmo.stat.gibdd.aggregator.domain.dto.AccidentParticipantDto;
import ru.itmo.stat.gibdd.aggregator.domain.entities.AccidentParticipant;
import ru.itmo.stat.gibdd.aggregator.repository.AccidentParticipantRepository;

@Service
public class AccidentParticipantService extends AbstractService<String, AccidentParticipantDto, AccidentParticipant, AccidentParticipantRepository> {
    private final AccidentParticipantRepository accidentParticipantRepository;

    @Autowired
    public AccidentParticipantService(AccidentParticipantRepository repository, ModelMapper modelMapper, AccidentParticipantRepository accidentParticipantRepository) {
        super(repository, modelMapper);
        this.accidentParticipantRepository = accidentParticipantRepository;
    }

    @Override
    public Class<AccidentParticipant> getEntityClass() {
        return AccidentParticipant.class;
    }

    @Override
    public Class<AccidentParticipantDto> getDTOClass() {
        return AccidentParticipantDto.class;
    }

    public void addAccidentParticipant(Long cardId, String participantId) {
        AccidentParticipantDto accidentParticipantDto = new AccidentParticipantDto();
        accidentParticipantDto.setAccidentId(cardId);
        accidentParticipantDto.setParticipantId(participantId);
        this.create(accidentParticipantDto);
    }
}

