package ru.itmo.stat.gibdd.aggregator.service;

import org.modelmapper.ModelMapper;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import ru.itmo.stat.gibdd.aggregator.domain.dto.AccidentRoadMaintenanceDisadvantageDto;
import ru.itmo.stat.gibdd.aggregator.domain.entities.AccidentRoadMaintenanceDisadvantage;
import ru.itmo.stat.gibdd.aggregator.repository.AccidentRoadMaintenanceDisadvantageRepository;

import java.util.List;

@Service
public class AccidentRoadMaintenanceDisadvantageService extends AbstractService<String, AccidentRoadMaintenanceDisadvantageDto, AccidentRoadMaintenanceDisadvantage, AccidentRoadMaintenanceDisadvantageRepository> {
    private final AccidentRoadMaintenanceDisadvantageRepository accidentRoadMaintenanceDisadvantageRepository;
    private final RoadMaintenanceDisadvantageService roadMaintenanceDisadvantageService;

    @Autowired
    public AccidentRoadMaintenanceDisadvantageService(AccidentRoadMaintenanceDisadvantageRepository repository, ModelMapper modelMapper, AccidentRoadMaintenanceDisadvantageRepository accidentRoadMaintenanceDisadvantageRepository, RoadMaintenanceDisadvantageService roadMaintenanceDisadvantageService) {
        super(repository, modelMapper);
        this.accidentRoadMaintenanceDisadvantageRepository = accidentRoadMaintenanceDisadvantageRepository;
        this.roadMaintenanceDisadvantageService = roadMaintenanceDisadvantageService;
    }

    @Override
    public Class<AccidentRoadMaintenanceDisadvantage> getEntityClass() {
        return AccidentRoadMaintenanceDisadvantage.class;
    }

    @Override
    public Class<AccidentRoadMaintenanceDisadvantageDto> getDTOClass() {
        return AccidentRoadMaintenanceDisadvantageDto.class;
    }

    public void addAccidentRoadMaintenanceDisadvantage(Long cardId, List<String> accidentRoadMaintenanceDisadvantage) {
        for (String w :
                accidentRoadMaintenanceDisadvantage) {
            AccidentRoadMaintenanceDisadvantageDto accidentRoadMaintenanceDisadvantageDto = new AccidentRoadMaintenanceDisadvantageDto();
            accidentRoadMaintenanceDisadvantageDto.setAccidentId(cardId);
            accidentRoadMaintenanceDisadvantageDto.setRoadMaintenanceDisadvantageId(roadMaintenanceDisadvantageService.getRoadMaintenanceDisadvantage(w).getId());
            this.create(accidentRoadMaintenanceDisadvantageDto);
        }
    }
}