package ru.itmo.stat.gibdd.aggregator.service;

import org.modelmapper.ModelMapper;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import ru.itmo.stat.gibdd.aggregator.domain.dto.AccidentRoadNetworkObjectDto;
import ru.itmo.stat.gibdd.aggregator.domain.entities.AccidentRoadNetworkObject;
import ru.itmo.stat.gibdd.aggregator.repository.AccidentRoadNetworkObjectRepository;

import java.util.List;

@Service
public class AccidentRoadNetworkObjectService extends AbstractService<String, AccidentRoadNetworkObjectDto, AccidentRoadNetworkObject, AccidentRoadNetworkObjectRepository> {
    private final AccidentRoadNetworkObjectRepository accidentRoadNetworkObjectRepository;
    private final RoadNetworkObjectService roadNetworkObjectService;

    @Autowired
    public AccidentRoadNetworkObjectService(AccidentRoadNetworkObjectRepository repository, ModelMapper modelMapper, AccidentRoadNetworkObjectRepository accidentRoadNetworkObjectRepository, RoadNetworkObjectService roadNetworkObjectService) {
        super(repository, modelMapper);
        this.accidentRoadNetworkObjectRepository = accidentRoadNetworkObjectRepository;
        this.roadNetworkObjectService = roadNetworkObjectService;
    }

    @Override
    public Class<AccidentRoadNetworkObject> getEntityClass() {
        return AccidentRoadNetworkObject.class;
    }

    @Override
    public Class<AccidentRoadNetworkObjectDto> getDTOClass() {
        return AccidentRoadNetworkObjectDto.class;
    }

    public void addAccidentRoadNetworkObject(Long cardId, List<String> accidentRoadNetworkObject) {
        for (String w:
                accidentRoadNetworkObject) {
            AccidentRoadNetworkObjectDto accidentRoadNetworkObjectDto = new AccidentRoadNetworkObjectDto();
            accidentRoadNetworkObjectDto.setAccidentId(cardId);
            accidentRoadNetworkObjectDto.setRoadNetworkObjectId(roadNetworkObjectService.getRoadNetworkObject(w).getId());
            this.create(accidentRoadNetworkObjectDto);
        }
    }
}
