package ru.itmo.stat.gibdd.aggregator.service;

import org.modelmapper.ModelMapper;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import ru.itmo.stat.gibdd.aggregator.domain.dto.AccidentVehicleDto;
import ru.itmo.stat.gibdd.aggregator.domain.entities.AccidentVehicle;
import ru.itmo.stat.gibdd.aggregator.repository.AccidentVehicleRepository;


@Service
public class AccidentVehicleService extends AbstractService<String, AccidentVehicleDto, AccidentVehicle, AccidentVehicleRepository> {
    private final AccidentVehicleRepository accidentVehicleRepository;
    private final VehicleService vehicleService;

    @Autowired
    public AccidentVehicleService(AccidentVehicleRepository repository, ModelMapper modelMapper, AccidentVehicleRepository accidentVehicleRepository, VehicleService vehicleService) {
        super(repository, modelMapper);
        this.accidentVehicleRepository = accidentVehicleRepository;
        this.vehicleService = vehicleService;
    }

    @Override
    public Class<AccidentVehicle> getEntityClass() {
        return AccidentVehicle.class;
    }

    @Override
    public Class<AccidentVehicleDto> getDTOClass() {
        return AccidentVehicleDto.class;
    }

    public void addAccidentVehicle(Long cardId, String vehicleId) {
        AccidentVehicleDto accidentVehicleDto = new AccidentVehicleDto();
        accidentVehicleDto.setVehicleId(vehicleId);
        accidentVehicleDto.setAccidentId(cardId);
        this.create(accidentVehicleDto);
    }
}