package ru.itmo.stat.gibdd.aggregator.service;

import org.modelmapper.ModelMapper;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import ru.itmo.stat.gibdd.aggregator.domain.dto.AccidentWeatherDto;
import ru.itmo.stat.gibdd.aggregator.domain.entities.AccidentWeather;
import ru.itmo.stat.gibdd.aggregator.repository.AccidentWeatherRepository;

import java.util.List;

@Service
public class AccidentWeatherService extends AbstractService<String, AccidentWeatherDto, AccidentWeather, AccidentWeatherRepository> {
    private final AccidentWeatherRepository accidentWeatherRepository;
    private final WeatherService weatherService;

    @Autowired
    public AccidentWeatherService(AccidentWeatherRepository repository, ModelMapper modelMapper, AccidentWeatherRepository accidentWeatherRepository, WeatherService weatherService) {
        super(repository, modelMapper);
        this.accidentWeatherRepository = accidentWeatherRepository;
        this.weatherService = weatherService;
    }

    @Override
    public Class<AccidentWeather> getEntityClass() {
        return AccidentWeather.class;
    }

    @Override
    public Class<AccidentWeatherDto> getDTOClass() {
        return AccidentWeatherDto.class;
    }

    public void addAccidentWeather(Long cardId, List<String> accidentWeather) {
        for (String w:
             accidentWeather) {
            AccidentWeatherDto accidentWeatherDto = new AccidentWeatherDto();
            accidentWeatherDto.setAccidentId(cardId);
            accidentWeatherDto.setWeatherId(weatherService.getWeatherId(w));
            this.create(accidentWeatherDto);
        }
    }
}