package ru.itmo.stat.gibdd.aggregator.service;

import org.modelmapper.ModelMapper;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import ru.itmo.stat.gibdd.aggregator.domain.dto.DrivingModeFactorDto;
import ru.itmo.stat.gibdd.aggregator.domain.entities.DrivingModeFactor;
import ru.itmo.stat.gibdd.aggregator.repository.DrivingModeFactorRepository;

import static ru.itmo.stat.gibdd.aggregator.utils.UUIDUtils.getUUIDFromString;

@Service
public class DrivingModeFactorService extends AbstractService<String, DrivingModeFactorDto, DrivingModeFactor, DrivingModeFactorRepository> {
    private final DrivingModeFactorRepository drivingModeFactorRepository;

    @Autowired
    public DrivingModeFactorService(DrivingModeFactorRepository repository, ModelMapper modelMapper, DrivingModeFactorRepository drivingModeFactorRepository) {
        super(repository, modelMapper);
        this.drivingModeFactorRepository = drivingModeFactorRepository;
    }

    @Override
    public Class<DrivingModeFactor> getEntityClass() {
        return DrivingModeFactor.class;
    }

    @Override
    public Class<DrivingModeFactorDto> getDTOClass() {
        return DrivingModeFactorDto.class;
    }

    public DrivingModeFactorDto getDrivingModeFactor(String drivingModeFactor) {
        String uuid = getUUIDFromString(drivingModeFactor);
        if (drivingModeFactorRepository.existsById(uuid)) {
            return this.modelMapper.map(drivingModeFactorRepository.findDrivingModeFactorById(uuid), getDTOClass());
        } else {
            DrivingModeFactorDto drivingModeFactorDto = new DrivingModeFactorDto();
            drivingModeFactorDto.setDrivingModeFactor(drivingModeFactor);
            drivingModeFactorDto.setId(uuid);
            return this.create(drivingModeFactorDto);
        }
    }
}