package ru.itmo.stat.gibdd.aggregator.service;

import org.modelmapper.ModelMapper;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import ru.itmo.stat.gibdd.aggregator.domain.dto.ParticipantMainTrafficViolationDto;
import ru.itmo.stat.gibdd.aggregator.domain.entities.ParticipantMainTrafficViolation;
import ru.itmo.stat.gibdd.aggregator.repository.ParticipantMainTrafficViolationRepository;

@Service
public class ParticipantMainTrafficViolationService extends AbstractService<String, ParticipantMainTrafficViolationDto, ParticipantMainTrafficViolation, ParticipantMainTrafficViolationRepository> {
    private final ParticipantMainTrafficViolationRepository participantMainTrafficViolationsRepository;

    @Autowired
    public ParticipantMainTrafficViolationService(ParticipantMainTrafficViolationRepository repository, ModelMapper modelMapper, ParticipantMainTrafficViolationRepository participantMainTrafficViolationsRepository) {
        super(repository, modelMapper);
        this.participantMainTrafficViolationsRepository = participantMainTrafficViolationsRepository;
    }

    @Override
    public Class<ParticipantMainTrafficViolation> getEntityClass() {
        return ParticipantMainTrafficViolation.class;
    }

    @Override
    public Class<ParticipantMainTrafficViolationDto> getDTOClass() {
        return ParticipantMainTrafficViolationDto.class;
    }

    public void addParticipantMainTrafficViolation(String participantId, String violationId) {
        ParticipantMainTrafficViolationDto participantMainTrafficViolationsDto = new ParticipantMainTrafficViolationDto();
        participantMainTrafficViolationsDto.setViolationId(violationId);
        participantMainTrafficViolationsDto.setParticipantId(participantId);
        this.create(participantMainTrafficViolationsDto);
    }
}

