package ru.itmo.stat.gibdd.aggregator.service;

import org.modelmapper.ModelMapper;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import ru.itmo.stat.gibdd.aggregator.domain.dto.ParticipantRelatedTrafficViolationDto;
import ru.itmo.stat.gibdd.aggregator.domain.entities.ParticipantRelatedTrafficViolation;
import ru.itmo.stat.gibdd.aggregator.repository.ParticipantRelatedTrafficViolationRepository;

@Service
public class ParticipantRelatedTrafficViolationService extends AbstractService<String, ParticipantRelatedTrafficViolationDto, ParticipantRelatedTrafficViolation, ParticipantRelatedTrafficViolationRepository> {
    private final ParticipantRelatedTrafficViolationRepository participantRelatedTrafficViolationsRepository;

    @Autowired
    public ParticipantRelatedTrafficViolationService(ParticipantRelatedTrafficViolationRepository repository, ModelMapper modelMapper, ParticipantRelatedTrafficViolationRepository participantRelatedTrafficViolationsRepository) {
        super(repository, modelMapper);
        this.participantRelatedTrafficViolationsRepository = participantRelatedTrafficViolationsRepository;
    }

    @Override
    public Class<ParticipantRelatedTrafficViolation> getEntityClass() {
        return ParticipantRelatedTrafficViolation.class;
    }

    @Override
    public Class<ParticipantRelatedTrafficViolationDto> getDTOClass() {
        return ParticipantRelatedTrafficViolationDto.class;
    }

    public void addParticipantRelatedTrafficViolation(String participantId, String violationId) {
        ParticipantRelatedTrafficViolationDto participantRelatedTrafficViolationsDto = new ParticipantRelatedTrafficViolationDto();
        participantRelatedTrafficViolationsDto.setViolationId(violationId);
        participantRelatedTrafficViolationsDto.setParticipantId(participantId);
        this.create(participantRelatedTrafficViolationsDto);
    }
}

