package ru.itmo.stat.gibdd.aggregator.service;

import org.modelmapper.ModelMapper;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import ru.itmo.stat.gibdd.aggregator.domain.dto.ParticipantDto;
import ru.itmo.stat.gibdd.aggregator.domain.entities.Participant;
import ru.itmo.stat.gibdd.aggregator.repository.ParticipantRepository;

import static ru.itmo.stat.gibdd.aggregator.utils.UUIDUtils.getUUIDFromString;

@Service
public class ParticipantService extends AbstractService<String, ParticipantDto, Participant, ParticipantRepository> {
    private final ParticipantRepository participantRepository;

    @Autowired
    public ParticipantService(ParticipantRepository repository, ModelMapper modelMapper, ParticipantRepository participantRepository) {
        super(repository, modelMapper);
        this.participantRepository = participantRepository;
    }

    @Override
    public Class<Participant> getEntityClass() {
        return Participant.class;
    }

    @Override
    public Class<ParticipantDto> getDTOClass() {
        return ParticipantDto.class;
    }

    public String addParticipant(ParticipantDto participantDto, Long cardId) {
        String uuid = getUUIDFromString(cardId.toString() + "-" + String.valueOf(participantDto.getParticipantNumber()));
        participantDto.setId(uuid);
        participantRepository.save(modelMapper.map(participantDto, getEntityClass()));
        return uuid;
    }
}