package ru.itmo.stat.gibdd.aggregator.service;

import org.modelmapper.ModelMapper;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import ru.itmo.stat.gibdd.aggregator.domain.dto.VehicleDto;
import ru.itmo.stat.gibdd.aggregator.domain.entities.Vehicle;
import ru.itmo.stat.gibdd.aggregator.repository.VehicleRepository;

import static ru.itmo.stat.gibdd.aggregator.utils.UUIDUtils.getUUIDFromString;

@Service
public class VehicleService extends AbstractService<String, VehicleDto, Vehicle, VehicleRepository> {
    private final VehicleRepository vehicleRepository;

    @Autowired
    public VehicleService(VehicleRepository repository, ModelMapper modelMapper, VehicleRepository vehicleRepository) {
        super(repository, modelMapper);
        this.vehicleRepository = vehicleRepository;
    }

    @Override
    public Class<Vehicle> getEntityClass() {
        return Vehicle.class;
    }

    @Override
    public Class<VehicleDto> getDTOClass() {
        return VehicleDto.class;
    }

    public String addVehicle(VehicleDto vehicleDto, Long cardId) {
        String uuid = getUUIDFromString(cardId.toString() + "-" + vehicleDto.getVehicleNumber().toString());
        vehicleDto.setId(uuid);
        vehicleRepository.save(modelMapper.map(vehicleDto, getEntityClass()));
        return uuid;
    }
}